build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.21.0-debug
    entrypoint: [""]
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_BRANCH}"
      --destination "${CI_REGISTRY_IMAGE}:latest"

staging:
  cache:
    paths:
      - _freeze
  stage: deploy
  image: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_BRANCH}
  script:
    - echo "Building the project with Quarto..."
    - quarto render --to html --output-dir public
  artifacts:
    paths:
      - public

pages:
  stage: deploy
  script:
    - echo "Publishing site..."
  needs:
    - staging
  artifacts:
    paths:
      - public
  rules:
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"

include:
  - local: ghost-upload/.gitlab-ci.yml
